using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace CursorTest
{
	/// <summary>
	/// Created by Markus Seitz, March 2006
	/// Purpose: Demonstrates
	/// 1. Creating a bitmap image from the contents of a picturebox
	/// 2. Use of picturebox as a cross-hair for mouse position in a graph or chart
	/// Copyright: Go nuts, it's yours
	/// Keywords: graph chart mouse position crosshair, cross, hair,cross-hair
	/// </summary>
	public class frmChart : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button btnClose;
		private System.Windows.Forms.Button btnCopy;
		private System.Windows.Forms.Button btnPaste;
		private System.Windows.Forms.PictureBox picHorizontalHair;
		private System.Windows.Forms.PictureBox picGraph;
		private System.Windows.Forms.Button btnClear;
		private System.Windows.Forms.PictureBox picVerticalHair;

		//need this reference for BitBlt
		[System.Runtime.InteropServices.DllImport("gdi32.dll")]
		public static extern long BitBlt (IntPtr hdcDest, int nXDest, int nYDest, int nWidth, int nHeight, IntPtr hdcSrc, int nXSrc, int nYSrc, int dwRop);
		private Bitmap mbmpMemoryImage;


		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmChart()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnClose = new System.Windows.Forms.Button();
			this.btnCopy = new System.Windows.Forms.Button();
			this.picGraph = new System.Windows.Forms.PictureBox();
			this.btnPaste = new System.Windows.Forms.Button();
			this.picHorizontalHair = new System.Windows.Forms.PictureBox();
			this.picVerticalHair = new System.Windows.Forms.PictureBox();
			this.btnClear = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// btnClose
			// 
			this.btnClose.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnClose.Location = new System.Drawing.Point(355, 295);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 1;
			this.btnClose.Text = "&Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// btnCopy
			// 
			this.btnCopy.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnCopy.Location = new System.Drawing.Point(0, 295);
			this.btnCopy.Name = "btnCopy";
			this.btnCopy.Size = new System.Drawing.Size(100, 23);
			this.btnCopy.TabIndex = 2;
			this.btnCopy.Text = "Cre&ate Image";
			this.btnCopy.Click += new System.EventHandler(this.btnCopy_Click);
			// 
			// picGraph
			// 
			this.picGraph.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.picGraph.Location = new System.Drawing.Point(0, 0);
			this.picGraph.Name = "picGraph";
			this.picGraph.Size = new System.Drawing.Size(430, 290);
			this.picGraph.TabIndex = 3;
			this.picGraph.TabStop = false;
			this.picGraph.MouseMove += new System.Windows.Forms.MouseEventHandler(this.picGraph_MouseMove);
			// 
			// btnPaste
			// 
			this.btnPaste.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnPaste.Location = new System.Drawing.Point(112, 295);
			this.btnPaste.Name = "btnPaste";
			this.btnPaste.Size = new System.Drawing.Size(95, 23);
			this.btnPaste.TabIndex = 4;
			this.btnPaste.Text = "&Use Image";
			this.btnPaste.Click += new System.EventHandler(this.btnPaste_Click);
			// 
			// picHorizontalHair
			// 
			this.picHorizontalHair.BackColor = System.Drawing.SystemColors.ControlText;
			this.picHorizontalHair.Location = new System.Drawing.Point(115, 90);
			this.picHorizontalHair.Name = "picHorizontalHair";
			this.picHorizontalHair.Size = new System.Drawing.Size(100, 20);
			this.picHorizontalHair.TabIndex = 7;
			this.picHorizontalHair.TabStop = false;
			this.picHorizontalHair.MouseMove += new System.Windows.Forms.MouseEventHandler(this.picHorizontalHair_MouseMove);
			// 
			// picVerticalHair
			// 
			this.picVerticalHair.BackColor = System.Drawing.SystemColors.ControlText;
			this.picVerticalHair.Location = new System.Drawing.Point(155, 50);
			this.picVerticalHair.Name = "picVerticalHair";
			this.picVerticalHair.Size = new System.Drawing.Size(25, 115);
			this.picVerticalHair.TabIndex = 8;
			this.picVerticalHair.TabStop = false;
			this.picVerticalHair.MouseMove += new System.Windows.Forms.MouseEventHandler(this.picVerticalHair_MouseMove);
			// 
			// btnClear
			// 
			this.btnClear.Location = new System.Drawing.Point(240, 295);
			this.btnClear.Name = "btnClear";
			this.btnClear.TabIndex = 9;
			this.btnClear.Text = "Cl&ear";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// frmChart
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(432, 321);
			this.Controls.Add(this.btnClear);
			this.Controls.Add(this.picVerticalHair);
			this.Controls.Add(this.picHorizontalHair);
			this.Controls.Add(this.btnPaste);
			this.Controls.Add(this.picGraph);
			this.Controls.Add(this.btnCopy);
			this.Controls.Add(this.btnClose);
			this.Name = "frmChart";
			this.Text = "Crosshairdemo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmChart());
		}

		

		private void btnCopy_Click(object sender, System.EventArgs e)
		{
			
			

			//hide the crosshar
			picHorizontalHair.Visible=false;
			picVerticalHair.Visible=false;
			picGraph.Refresh();

			//Draw the graph
			Graphics oGrpahics=picGraph.CreateGraphics();
			oGrpahics.DrawLine(new Pen(Color.Blue),0,picGraph.Height,picGraph.Width,0);

			//Copy from picturebox to memory
			Graphics grphSource = picGraph.CreateGraphics();
			Size s = picGraph.Size;
			mbmpMemoryImage = new Bitmap(s.Width, s.Height, grphSource);
			Graphics grphInvisible = Graphics.FromImage(mbmpMemoryImage);
			//get handles for graphics objects
			IntPtr ptrSource = grphSource.GetHdc();
			IntPtr ptrTarget = grphInvisible.GetHdc();
			//NB see above for reference to DllImport("gdi32.dll")
			BitBlt(ptrTarget, 0, 0, picGraph.ClientRectangle.Width, picGraph.ClientRectangle.Height, ptrSource, 0, 0, 0x00CC0020 /* dest = source*/);
			//and clean up
			grphSource.ReleaseHdc(ptrSource);
			grphInvisible.ReleaseHdc(ptrTarget);
			
			//show the crosshairs again
			picHorizontalHair.Visible=true;
			picVerticalHair.Visible=true;

			
		}

		private void btnPaste_Click(object sender, System.EventArgs e)
		{
			//assigned the copied image to the picturebox
			picGraph.Image = mbmpMemoryImage;
		}


		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}


		private void picGraph_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			picVerticalHair.Left=picGraph.Left+e.X;
			picHorizontalHair.Top=picGraph.Top+e.Y;
		}


		private void Form1_Load(object sender, System.EventArgs e)
		{
			//set up the crosshairs
			picHorizontalHair.Height=1;
			picHorizontalHair.Top=picGraph.Top + picGraph.Height;
			picHorizontalHair.Width=picGraph.Width;
			picHorizontalHair.Left=picGraph.Left;

			picVerticalHair.Width=1;
			picVerticalHair.Height=picGraph.Height;
			picVerticalHair.Top=picGraph.Top;
			picVerticalHair.Left=picGraph.Left;

			

		}


		private void picHorizontalHair_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//this occurs when the mouse moves onto the crosshair 
			picVerticalHair.Left=picGraph.Left+e.X;
		}


		private void picVerticalHair_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			//this occurs when the mouse moves onto the crosshair 
			picHorizontalHair.Top=picGraph.Top+e.Y;
		}

		private void btnClear_Click(object sender, System.EventArgs e)
		{
			picGraph.Image=null;
			picGraph.Refresh();
		}

		/*
			//Copy from one picture to another
				Graphics grphSource = picSource.CreateGraphics();
				IntPtr ptrSourceHandle = grphSource.GetHdc();
				Graphics grphTarget = picGraph.CreateGraphics();
				IntPtr ptrDestHandle=grphTarget.GetHdc();
				BitBlt(ptrDestHandle, 0, 0, picSource.ClientRectangle.Width, picSource.ClientRectangle.Height, ptrSourceHandle, 0, 0, 13369376);
				grphSource.ReleaseHdc(ptrSourceHandle);
				grphTarget.ReleaseHdc(ptrDestHandle);
			*/
	}
}
